#!/usr/bin/env python
# -*- coding: utf-8 -*-

# mask gamma encoding
# apply gamma encoding to visible layers' masks

from gimpfu import *
import os, glob

def mask_gamma_encoding(image, option, invert):
    # option is Gamma value
    if option == 0:
        value = 1 / 2.2
    elif option == 1:
        value = 1 / 1.1
    elif option == 3:
        value = 1.1
    elif option == 4:
        value = 2.2
    elif option == 5:
        value = 4.4
    else:
        value = 1.0
    pdb.gimp_message_get_handler(ERROR_CONSOLE)
    pdb.gimp_image_set_active_layer(image, image.layers[0])
    # set top layer active
    #gimp.message(str(len(image.layers)))
    pdb.gimp_image_undo_group_start(image)
    for i in range(len(image.layers)): # iterate process to each layer
        #gimp.message("roop: " + str(i))
        pdb.gimp_image_set_active_layer(image, image.layers[i])
        # set i th layer active
        mask = pdb.gimp_layer_get_mask(pdb.gimp_image_get_active_layer(image))
        # the active layer has mask?
        visible = pdb.gimp_item_get_visible(pdb.gimp_image_get_active_layer(image))
        if mask != None and visible == TRUE: # if the layer is visble and has mask...
            try:
                pdb.gimp_layer_set_edit_mask(pdb.gimp_image_get_active_layer(image), FALSE)
                # set mask editing mode off
                pdb.gimp_layer_set_edit_mask(pdb.gimp_image_get_active_drawable(image), TRUE)
                # set mask editing mode on and make the mask active
                pdb.gimp_drawable_levels(pdb.gimp_image_get_active_drawable(image) ,0 ,0,1 ,FALSE ,value ,0 ,1 ,FALSE)
                # Gamma encoding with value of mask image
                if invert == True:
                    pdb.gimp_drawable_invert(pdb.gimp_image_get_active_drawable(image) ,FALSE)
                    # invert mask image
            except Exception, error:
                print error
    pdb.gimp_image_undo_group_end(image)
    pdb.gimp_image_set_active_layer(image, image.layers[0])
    # set top layer active
    mask = pdb.gimp_layer_get_mask(pdb.gimp_image_get_active_layer(image))
    # whether top layer has mask
    #gimp.message("mask?: " + str(mask))
    if mask != None: # if top layer has mask
        pdb.gimp_layer_set_edit_mask(pdb.gimp_image_get_active_layer(image), FALSE)
        # set top layer mask editing mode off
    return
register(
    "mask_gamma_encoding",
    "Mask gamma encoding",
    "Mask gamma encoding",
    "Ohnishi, Yasuo",
    "Ohnishi, Yasuo",
    "2022 Ver 0.2",
    "可視レイヤーマスクをガンマ補正...",
    "*",      # Alternately use RGB, RGB*, GRAY*, INDEXED etc.
    [
        (PF_IMAGE, "image", "input image", None),
        (PF_OPTION, "option", "ガンマ補正値", 4, ("1/2.2" ,"1/1.1" ,"1.0" ,"1.1", "2.2", "4.4")),
        (PF_BOOL,   "invert", "反転", False),
    ],
    [],
    mask_gamma_encoding, menu="<Image>/Layer/" )
main()
